<template>
  <div class="marker-list-control">
    <div>Объекты</div>
    <div>
      <input v-model="search" @input="debounceInput" placeholder="Поиск..." />
    </div>
    <div class="marker-list">
      <ul>
        <li
          v-for="marker in filteredObjects"
          :key="marker.id"
          v-on:click="say(marker.id)"
          :style="{ background: selectedListItem === marker.id ? 'red' : '' }"
        >
          {{ marker.name }}
        </li>
      </ul>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      search: "",
      filteredObjects: [],
      selectedListItem: null,
    };
  },
  props: ["objects", "selectedObject"],

  methods: {
    say: function (event) {
      this.selectedListItem = event;
      this.$emit("ObjectSelected", event);
    },
    debounceInput: function () {
      this.filteredObjects = this.objects.filter((elm) =>
        elm.name.toLowerCase().includes(this.search)
      );
    },
  },
  watch: {
    objects: {
      immediate: true,
      handler(val) {
        this.filteredObjects = val;
        this.objects = val;
      },
    },
    selectedObject: {
      immediate: true,
      handler(val) {
        this.selectedListItem = val;
      },
    },
  },
};
</script>
<style scoped>
input {
  border: none;
  outline: none;
}
.marker-list-control {
  background: #fff;
  padding: 0 0.5em;
  border: 1px solid #aaa;
  border-radius: 0.1em;
  margin-right: 20px;
  margin-top: 20px;
}
.marker-list ul {
  list-style: none;
}
.marker-list ul li {
  cursor: pointer;
}
</style>